#include <cglib/core/glheaders.h>
#include <cglib/core/assert.h>

#include <cglib/gl/device_rendering_context.h>
#include <cglib/gl/device_render.h>
#include <cglib/gl/renderer.h>


int
main(int argc, char const**argv)
{
	DeviceRenderingContext context;
    if (!context.params.parse_command_line(argc, argv)) {
        std::cerr << "invalid command line argument" << std::endl;
        return -1;
    }
	context.renderers.insert({DeviceRenderingParameters::CUBE,         std::make_shared<CubeRenderer>()});
	context.renderers.insert({DeviceRenderingParameters::MONKEY,       std::make_shared<MonkeyRenderer>()});
	context.renderers.insert({DeviceRenderingParameters::SPHERE_FLAKE, std::make_shared<SphereFlakeRenderer>()});
	context.renderers.insert({DeviceRenderingParameters::SPONZA,       std::make_shared<SponzaRenderer>()});

    return DeviceRender::run(context, true);
}

// CG_REVISION 885e1973ef13e23627507a0eced17e88065a621b
