#pragma once

#include <cglib/core/parameters.h>

struct CTwBar;
/*
 * Raytracing parameters.
 *
 * Have a look at cglib/parameters.h to see which parameters are built-in already.
 * Feel free to add more parameters here. You can add them to the AntTweakBar gui,
 * aswell, to make interactive tweaking easier.
 */
class DeviceRenderingParameters : public Parameters
{
public:
	enum Renderers {
		CUBE,
		MONKEY,
		SPONZA,
		SPHERE_FLAKE,
	};
	DeviceRenderingParameters() {}
	~DeviceRenderingParameters() {}

	/* restart means reinitialization for device rendering */
	virtual bool derived_change_requires_restart(Parameters const& old_) const override final;

	virtual void derived_gui_setup(CTwBar* main_bar) final;

	float near_clip = 0.05f, far_clip = 200.0f;

	float fov = 60.0f;
	Renderers current_renderer = CUBE;

	bool enable_animation = true;
	
	struct SphereParams {
		int recursion_depth = 3;
		float animation_speed = 0.1f;
		float size_factor = 0.5f;
	} sphere_flake;

};
