#include <cglib/gl/renderer.h>

const MapNameProgramDefinition CubeRenderer::program_definitions = {
	{	"simple",
		{ { "shader/simple.vert" }
		, { "shader/simple.frag" }
		, { "gl_Position", "color" }
		}
	},
};

const MapNameProgramDefinition MonkeyRenderer::program_definitions = {
	{	"env_light",
		{ { "shader/env_light.vert" }
		, { "shader/env_light.frag" }
		, { "world_position", "world_normal_interpolated", "gl_Position" }
		}
	},
	{	"env_bg",
		{ { "shader/env_bg.vert" }
		, { "shader/env_bg.frag" }
		, { "viewdir_interpolated", "gl_Position" }
		}
	},
};

const MapNameProgramDefinition HDRRenderer::program_definitions = {
	{	"tonemap",
		{ { "shader/tonemap.vert" }
		, { "shader/tonemap.frag" }
		}
	},
};

const MapNameProgramDefinition SponzaRenderer::program_definitions = {
	{	"simple_texture",
		{ { "shader/simple_texture.vert" }
		, { "shader/simple_texture.frag" }
		, { "normal", "gl_Position" }
		}
	},
	{	"phong",
		{ { "shader/phong.vert" }
		, { "shader/phong.frag" }
		, { "world_position", "world_normal_interpolated", "tex_coord", "gl_Position" }
		}
	},
};

const MapNameProgramDefinition SphereFlakeRenderer::program_definitions = {
	{	"simple",
		{ { "shader/simple.vert" }
		, { "shader/simple_tex.frag" }
		, { }
		}
	},
};

